// $Id: chainout.cpp,v 1.10 2006/10/17 02:10:58 erynes Exp $

/* 
 Copyright 2002 Peter Beerli, Mary Kuhner, Jon Yamato and Joseph Felsenstein

 This software is distributed free of charge for non-commercial use
 and is copyrighted.  Of course, we do not guarantee that the software
 works, and are not responsible for any damage you may cause or have.
*/

#include "chainout.h"

#ifdef DMALLOC_FUNC_CHECK
#include "/usr/local/include/dmalloc.h"
#endif

ChainOut::ChainOut()
: badtrees(FLAGLONG),
  tinypoptrees(FLAGLONG),
  zerodltrees(FLAGLONG),
  stretchedtrees(FLAGLONG),
  accrate(FLAGDOUBLE),
  numtemps(FLAGLONG),
  swaprates(),
  tempaccrates(),
  temperatures(),
  bayesunique(),
  starttime(0),
  endtime(0),
  estimates(unknown_region),
  llikemle(FLAGDOUBLE),
  llikedata(NEG_MAX)
{
// blank
} /* ChainOut */


//__________________________________________________

void ChainOut::SetStarttime() 
{
#ifdef NOTIME_FUNC
// The system does not provide a clock.  All times are 0.
  starttime = 0;
#else
  time_t nowtime;
  time (&nowtime);
  starttime = nowtime;
#endif
}

//__________________________________________________

void ChainOut::SetEndtime() 
{
#ifdef NOTIME_FUNC
// The system does not provide a clock.  All times are 0.
  endtime = 0;
#else
  time_t nowtime;
  time (&nowtime);
  endtime = nowtime;
#endif
}

