// $Id: ConverterIf.cpp,v 1.14 2002/07/10 00:09:11 mkkuhner Exp $

/* 
 Copyright 2002 Patrick Colacurcio, Peter Beerli, Mary Kuhner, 
                Jon Yamato and Joseph Felsenstein

 This software is distributed free of charge for non-commercial use
 and is copyrighted.  Of course, we do not guarantee that the software
 works, and are not responsible for any damage you may cause or have.
*/

#include "Converter_ConverterIf.h"
#include "Converter_DataSourceException.h"
#include "constants.h"

#include <iostream>
#include <sstream>
#include <ctype.h>
#include <string>

#include "stringx.h"

#ifdef DMALLOC_FUNC_CHECK
#include "/usr/local/include/dmalloc.h"
#endif

using namespace std;

const long DEFAULTLONG = 0;

//----------------------------------------------------------------------

ConverterIf::ConverterIf()
: ParserUtil()
{
}

//----------------------------------------------------------------------

ConverterIf::~ConverterIf()
{
}

//----------------------------------------------------------------------

long ConverterIf::FlagCheck(const string& origstring, 
                            const string& msg) const
{
  long number;

  if (!FromString(origstring,number))
    {
      string emsg = "\nEncountered an illegal value for " + msg;
      emsg += ", " + origstring + ".\n";
      throw FileFormatError(emsg);
    }

  return number;

} /* ConverterIf::FlagCheck */

//----------------------------------------------------------------------
