#ifndef GC_QUANTUM_H
#define GC_QUANTUM_H


#include "wx/clntdata.h"
#include "wx/string.h"

class GCQuantum
{
    private:
        static size_t       s_objCount;
    protected:
        size_t              m_objId;
        wxString            m_name;
        bool                m_selected;
    public:
        GCQuantum();
        /*
        GCQuantum(wxString name);
        */
        virtual ~GCQuantum();

                size_t      GetId()                         const;
                void        DebugDump(wxString prefix=wxEmptyString)   const;
        virtual wxString    GetName()                       const;
        virtual void        SetName(wxString name);

        /*
        virtual bool        GetSelected()                   const;
        virtual void        SetSelected(bool selected);
        */

        static  void        ReportMax();
};

class wxWindow;
class GCDataStore;

class gcEventActor
{
    public:
        gcEventActor() {};
        virtual ~gcEventActor() {};
        virtual bool OperateOn(wxWindow * parent, GCDataStore & store) = 0;
};

class GCClientData : public wxClientData
{
    private:
        GCClientData();         // undefined
        gcEventActor *          m_myActor;
    public:
        GCClientData(gcEventActor * myActor);
        virtual ~GCClientData();
        gcEventActor *  GetActor() ;
};

#endif
//GC_QUANTUM_H
