#ifndef REGIONGAMMAMENUS_H
#define REGIONGAMMAMENUS_H

/* 
 Copyright 2002  Peter Beerli, Mary Kuhner, Jon Yamato and Joseph Felsenstein

 This software is distributed free of charge for non-commercial use
 and is copyrighted.  Of course, we do not guarantee that the software
 works, and are not responsible for any damage you may cause or have.
*/

#include <string>
#include "newmenuitems.h"
#include "setmenuitem.h"

class UIInterface;

class RegionGammaShapeParameterMenuItem : public SetMenuItemId
{
    public:
        RegionGammaShapeParameterMenuItem(std::string myKey, UIInterface & myui);
        ~RegionGammaShapeParameterMenuItem();
        bool IsVisible();
};

class RegionGammaMenu : public NewMenu
{
    public:
        RegionGammaMenu(UIInterface & myui);
        virtual ~RegionGammaMenu();
};

class RegionGammaMenuCreator : public NewMenuCreator
{
    protected:
        UIInterface & ui;
    public:
        RegionGammaMenuCreator(UIInterface & myui) : ui(myui) {};
        virtual ~RegionGammaMenuCreator() {};
        NewMenu_ptr Create() { return NewMenu_ptr(new RegionGammaMenu(ui));};
};

#endif  /* REGIONGAMMAMENUS_H */
