// $Id: random.h,v 1.11 2007/07/10 23:46:41 jay Exp $

#ifndef RANDOM_H
#define RANDOM_H

/* 
 Copyright 2002  Peter Beerli, Mary Kuhner, Jon Yamato and Joseph Felsenstein

 This software is distributed free of charge for non-commercial use
 and is copyrighted.  Of course, we do not guarantee that the software
 works, and are not responsible for any damage you may cause or have.
*/

#include <string>

#define MAX_RANDOM  4294967296.0    // 2^31

class Random
{
           Random(const Random&);   // undefined
    Random operator=(Random);       // undefined

    long num0, num1, num2, num3;
    long n0, n1, n2, n3;
    long m0, m1, m2, m3;

    void Next();

  public:
    Random();
    Random(long);
    void Seed(long);
    // The following seeds the RNG from the system clock.  Warning:  if you
    // call it twice in quick succession the answer will probably be the same!
    // It is using *seconds*, not milliseconds.
    void ClockSeed();  
    void Read(char*);
    void Write(char*);
    void Advance(long);
    long Peek();
    long Long();
    long Long(long);
    double Float();
    char Base();
    bool Bool();
    std::string Name();
    double Normal();
};

#endif /* RANDOM_H */

